use apet_ex1::{circuit::Circuit, scalar_to_bits::scalar_to_bits};
use curve25519_dalek::Scalar;
use num_bigint::BigUint;
use rand::rngs::OsRng;

fn main() {
/* 

    let input_bits = vec![
//         A2     A1    A0
//          0      1     2
        false, false, true,
//         B2     B1    B0
//          3      4     5
        false, true, false
    ];


    let c = Circuit::compare_n_bit_numbers(input_bits, 3);
    let res = c.eval();
    println!("1 > 2 ? {}", res);
*/

    let a = Scalar::random(&mut OsRng);
    let b = Scalar::random(&mut OsRng);
    // Convert to bit representation
    let a_bits = scalar_to_bits(&a);
    let b_bits = scalar_to_bits(&b);

    // Combine A and B bits into one input vector
    let mut input_bits = Vec::with_capacity(512);
    input_bits.extend_from_slice(&a_bits);
    input_bits.extend_from_slice(&b_bits);

    // Build and evaluate the comparison circuit
    let circuit = Circuit::compare_n_bit_numbers(256, input_bits);
    let circuit_result = circuit.eval();

    let a_int = BigUint::from_bytes_le(&a.to_bytes());
    let b_int = BigUint::from_bytes_le(&b.to_bytes());

    println!("{}", circuit_result == (a_int > b_int))
}
