use curve25519_dalek::Scalar;

pub fn scalar_to_bits(scalar: &Scalar) -> Vec<bool> {
    let bytes = scalar.to_bytes();
    let mut bits = Vec::with_capacity(256);

    // MSB first
    for &byte in bytes.iter().rev() {
        for i in (0..8).rev() {
            let bit = (byte >> i) & 1;
            bits.push(bit != 0);
        }
    }

    bits
}
